"use strict";

var fs = require('fs');

var path = require('path');

var nunjucks = require('nunjucks');

function escapeWinPath(path) {
  return path.replace(/\\/g, '\\\\');
}

function getRoutesPath(tmpDirPath, themeConfig, themeRoutes, themePath, configEntryName) {
  var routesTemplate = fs.readFileSync(path.join(__dirname, 'routes.nunjucks.js')).toString();
  var routesPath = path.join(tmpDirPath, "routes.".concat(configEntryName, ".js"));
  fs.writeFileSync(routesPath, nunjucks.renderString(routesTemplate, {
    themePath: escapeWinPath(themePath),
    themeConfig: JSON.stringify(themeConfig || {}),
    themeRoutes: JSON.stringify(themeRoutes)
  }));
  return routesPath;
}

function generateEntryFile(tmpDirPath, themeConfig, themeRoutes, configTheme, configEntryName, root) {
  var entryTemplate = fs.readFileSync(path.join(__dirname, 'entry.nunjucks.js')).toString();
  var entryPath = path.join(tmpDirPath, "entry.".concat(configEntryName, ".js"));
  var routesPath = getRoutesPath(tmpDirPath, themeConfig, themeRoutes, path.dirname(configTheme), configEntryName);
  fs.writeFileSync(entryPath, nunjucks.renderString(entryTemplate, {
    routesPath: escapeWinPath(routesPath),
    root: escapeWinPath(root)
  }));
  return entryPath;
}

exports.getRoutesPath = getRoutesPath;
exports.generateEntryFile = generateEntryFile;
exports.htmlTemplate = path.join(__dirname, 'template.html');